//------------------------------------------------------------------------------
// Standard-Header-Einbindung (alphabetisch)                                   -
//------------------------------------------------------------------------------
#include <iomanip.h>
#include <iostream.h>
#include <string.h>

//------------------------------------------------------------------------------
// Header-Einbindung (alphabetisch)                                            -
//------------------------------------------------------------------------------
#include "HQG_Person.h"

//------------------------------------------------------------------------------
// Header-Einbindung (alphabetisch)                                            -
//------------------------------------------------------------------------------
#define STRINGENDE '0'

//------------------------------------------------------------------------------
// Standard-Constructor                                                        -
//------------------------------------------------------------------------------
HQGPerson::HQGPerson (void)
{
   strcpy (Vorname,  "");
   strcpy (Nachname, "");
}

//------------------------------------------------------------------------------
// Copy-Constructor                                                            -
//------------------------------------------------------------------------------
HQGPerson::HQGPerson (const HQGPerson& x)
{
	//---------------------------------------------------------------------------
	// Daten aus dem bergebenen Objekt bernehmen                              -
	//---------------------------------------------------------------------------
   SetVorname  (x.Vorname);
   SetNachname (x.Nachname);
}

//------------------------------------------------------------------------------
// Destructor                                                                  -
//------------------------------------------------------------------------------
HQGPerson::~HQGPerson (void)
{
	//---------------------------------------------------------------------------
   // derzeit nix                                                              -
	//---------------------------------------------------------------------------
}

//------------------------------------------------------------------------------
// GetNachname                                                                 -
//------------------------------------------------------------------------------
const char *HQGPerson::GetNachname (void)
{
	return Nachname;
}

//------------------------------------------------------------------------------
// GetVorname                                                                  -
//------------------------------------------------------------------------------
const char *HQGPerson::GetVorname  (void)
{
	return Vorname;
}

//------------------------------------------------------------------------------
// Input (Console)                                                             -
//------------------------------------------------------------------------------
void HQGPerson::ConsoleInput (void)
{
	char szBuffer [2000];

	//---------------------------------------------------------------------------
	// Vornamen einlesen                                                        -
	//---------------------------------------------------------------------------
	cout << setw(2) << "Vorname : ";
   cin.getline (szBuffer, HQGPERSON_NAMELEN);
   SetVorname (szBuffer);

	//---------------------------------------------------------------------------
	// Nachnamen einlesen                                                       -
	//---------------------------------------------------------------------------
   cout << setw(2) << "Nachname: ";
   cin.getline (szBuffer, HQGPERSON_NAMELEN);
   SetNachname (szBuffer);
}

//------------------------------------------------------------------------------
// Operator <                                                                  -
//------------------------------------------------------------------------------
bool HQGPerson::operator< (const HQGPerson& x) const
{
   bool rc  = false;
   int  cmp =  strcmp (Nachname, x.Nachname);

   //---------------------------------------------------------------------------
   // Wenn Nachname in x lexikalisch grer ist, dann ist operator< erfllt    -
   //---------------------------------------------------------------------------
	if (0 > cmp)
   {
	   rc = true;
   }
   else
   {
	   //------------------------------------------------------------------------
   	// Wenn Nachnamen gleich sind, dann Vornamen prfen                      -
   	//------------------------------------------------------------------------
      if (0 == cmp)
      {
		   if (0 > strcmp (Vorname, x.Vorname))
         {
	         rc = true;
         }
      }
   }

   return rc;
}

//------------------------------------------------------------------------------
// SetNachname                                                                 -
//------------------------------------------------------------------------------
void HQGPerson::SetNachname (const char *x)
{
	//---------------------------------------------------------------------------
	// Wenn der bergebene String zu lang fr den Namen im Objekt ist, mu zu-  -
   // zuerst auf einer Kopie gekrzt werden                                    -
	//---------------------------------------------------------------------------
	if (strlen (x) > HQGPERSON_NAMELEN)
   {
		char szBuffer [2000];

		strncpy  (szBuffer, x, 2000);
		szBuffer [HQGPERSON_NAMELEN] = STRINGENDE;
		strcpy   (Nachname, x);
   }
   else
   {
		strcpy (Nachname, x);
   }
}

//------------------------------------------------------------------------------
// SetVorname                                                                  -
//------------------------------------------------------------------------------
void HQGPerson::SetVorname (const char *x)
{
	//---------------------------------------------------------------------------
	// Wenn der bergebene String zu lang fr den Namen im Objekt ist, mu zu-  -
   // zuerst auf einer Kopie gekrzt werden                                    -
	//---------------------------------------------------------------------------
	if (strlen (x) > HQGPERSON_NAMELEN)
   {
		char szBuffer [2000];

		strncpy  (szBuffer, x, 2000);
		szBuffer [HQGPERSON_NAMELEN] = STRINGENDE;
		strcpy   (Vorname, x);
   }
   else
   {
		strcpy (Vorname,  x);
   }
}

