#ifndef _hqgperson_h_
   #define _hqgperson_h_

   //---------------------------------------------------------------------------
   // eigene Klasse, die ber den generischen SORT-Algorithmus sortiert wird   -
   //---------------------------------------------------------------------------
	#define HQGPERSON_NAMELEN         40
   #define HQGPERSON_NAMEDECLARATION HQGPERSON_NAMELEN+1
   class HQGPerson
   {
      public:
		   //---------------------------------------------------------------------
         // Constructoren / Destructor                                         -
		   //---------------------------------------------------------------------
          HQGPerson (void);
          HQGPerson (const HQGPerson& x);
         ~HQGPerson (void);

		   //---------------------------------------------------------------------
         // Eingabemethoden                                                    -
		   //---------------------------------------------------------------------
         const char *GetNachname (void);
         const char *GetVorname  (void);

         void  ConsoleInput      (void);

		   //---------------------------------------------------------------------
         // Operatoren                                                         -
		   //---------------------------------------------------------------------
			bool operator< (const HQGPerson& x) const;

		   //---------------------------------------------------------------------
         // Ausgabemethoden                                                    -
		   //---------------------------------------------------------------------
			void SetNachname  (const char *x);
         void SetVorname   (const char *x);

      protected:
   	   char Vorname  [HQGPERSON_NAMEDECLARATION];
   	   char Nachname [HQGPERSON_NAMEDECLARATION];
   };


#endif // _hqgperson_h_
